<?php
/**
* @version      2.6.0 25.11.2010
* @author       MAXXmarketing GmbH
* @package      Jshopping
* @copyright    Copyright (C) 2010 webdesigner-profi.de. All rights reserved.
* @license      GNU/GPL
*/

class jshopProduct extends JTableAvto {    

    function __construct( &$_db ){
        parent::__construct( '#__jshopping_products', 'product_id', $_db );
    }
    
    function setAttributeActive($attribs){
        $this->attribute_active = $attribs;
        if (is_array($this->attribute_active) && count($this->attribute_active)){
            $where = "";
            foreach($this->attribute_active as $k=>$v){
                $where.=" and PA.attr_".$k." = '".$this->_db->getEscaped($v)."' ";
            }          
            $query = "select PA.* from `#__jshopping_products_attr` as PA where PA.product_id = '".$this->_db->getEscaped($this->product_id)."' ".$where; 
            $this->_db->setQuery($query);
            $this->attribute_active_data = $this->_db->loadObject();    
        }else{
            $this->attribute_active_data = NULL;
        }
    }
    
    function getRequireAttribute(){
        $jshopConfig = &JSFactory::getConfig();
        if (!$jshopConfig->admin_show_attributes) return array();
        
        $attribs = &JSFactory::getAllAttributes();
        $prodAttribVal = $this->getAttributes();
        $require = array();
        if (count($prodAttribVal)){             
            $prodAtrtib = $prodAttribVal[0];
            foreach($attribs as $attrib){
                $field = "attr_".$attrib->attr_id;
                if ($prodAtrtib->$field) $require[] = $attrib->attr_id;
            }
        }
        return $require;
    }
    
    function getAttributes() {
        $query = "SELECT * FROM `#__jshopping_products_attr` WHERE product_id = '".$this->product_id."' ORDER BY product_attr_id";
        $this->_db->setQuery($query);
        return $this->_db->loadObjectList();
    }    
    
    function getAttribValue($attr_id, $other_attr = array(), $onlyExistProduct = 0){
        $lang = &JSFactory::getLang();
        $where = "";
        foreach($other_attr as $k=>$v){
            $where.=" and PA.attr_$k='$v'";
        }
        if ($onlyExistProduct) $where.=" and PA.count>0 ";
        
        $field = "attr_".$attr_id;
        $query = "SELECT distinct PA.$field as val_id, V.`".$lang->get("name")."` as value_name, V.image
                  FROM `#__jshopping_products_attr` as PA INNER JOIN #__jshopping_attr_values as V ON PA.$field=V.value_id
                  WHERE PA.product_id = '".$this->product_id."' ".$where."
                  ORDER BY V.value_ordering";
        $this->_db->setQuery($query);
        return $this->_db->loadObjectList();
    }
    
    function getAttributesDatas($selected = array()){                        
        $jshopConfig = &JSFactory::getConfig();        
        $data = array();
        $requireAttribute = $this->getRequireAttribute();
        $actived = array();
        foreach($requireAttribute as $attr_id){
            $options = $this->getAttribValue($attr_id, $actived, $jshopConfig->hide_product_not_avaible_stock);
            $data['attributeValues'][$attr_id] = $options;
            if (!$jshopConfig->product_attribut_first_value_empty){
                $actived[$attr_id] = $options[0]->val_id;
            }
            if ($selected[$attr_id]){
                $testActived = 0;
                foreach($options as $tmp) if ($tmp->val_id==$selected[$attr_id]) $testActived = 1;
                if ($testActived){
                    $actived[$attr_id] = $selected[$attr_id];
                }
            }
        }
        
        if (count($requireAttribute) == count($actived)){
            $data['attributeActive'] = $actived;
        }else{
            $data['attributeActive'] = array();
        }
        
        $data['attributeSelected'] = $actived;
        return $data;
    }

    function getCategories() {
        $db =& JFactory::getDBO(); 
        $query = "SELECT * FROM `#__jshopping_products_to_categories` WHERE product_id = '".$this->_db->getEscaped($this->product_id)."'";
        $this->_db->setQuery($query);
        return $this->_db->loadObjectList();
    }

    function getName() {
        $lang = &JSFactory::getLang();
        $name = $lang->get('name');
        return $this->$name;
    }

    function updateProductInStock($listProducts) {
        $db =& JFactory::getDBO(); 

        foreach ($listProducts as $prod) {
            if ( is_array($prod['attr']) && count($prod['attr']) ){                
                $where="";
                foreach($prod['attr'] as $k=>$v){
                    $where.=" and `attr_$k`='".intval($v)."'";        
                }
                $query = "update `#__jshopping_products_attr` set `count`=`count`-".intval($prod['quantity'])." where product_id='".intval($prod['product_id'])."' ".$where;
                $db->setQuery($query);
                $db->query();
                
                $query="select sum(count) as qty from `#__jshopping_products_attr` where product_id='".intval($prod['product_id'])."' and `count`>0 ";
                $db->setQuery($query);
                $qty = $db->loadResult();
                
                $query = "UPDATE `#__jshopping_products` SET product_quantity = '".intval($qty)."' WHERE product_id = '".intval($prod['product_id'])."'";
                $db->setQuery($query);
                $db->query();
                
            }else{
                $query = "UPDATE `#__jshopping_products` SET product_quantity = product_quantity - ".intval($prod['quantity'])." WHERE product_id = '".intval($prod['product_id'])."'";
                $db->setQuery($query);
                $db->query();
            }
        }
        
    }

    function getPriceWithParams(){
        if (isset($this->attribute_active_data->price)){
            return $this->attribute_active_data->price;
        }else{
            return $this->product_price;
        }
    }
    
    function getEan(){   
        if (isset($this->attribute_active_data->ean)){     
            return $this->attribute_active_data->ean;
        }else{
            return $this->product_ean;
        }
    }
    
    function getQty(){
        if (isset($this->attribute_active_data->count)){
            return $this->attribute_active_data->count;
        }else{
            return $this->product_quantity;
        }
    }
    
    function getQtyInStock(){
        $qtyInStock = $this->getQty();        
        if ($qtyInStock < 0) $qtyInStock = 0;
    return $qtyInStock;
    }

    function getImages() {        
        $query = "SELECT I.*, IF(P.product_name_image=I.image_name,0,1) as sort FROM `#__jshopping_products_images` as I left join `#__jshopping_products` as P on P.product_id=I.product_id
                 WHERE I.product_id = '" . $this->_db->getEscaped($this->product_id) . "' ORDER BY sort,I.image_id";
        $this->_db->setQuery($query);
        return $this->_db->loadObjectList();
    }

    function getVideos(){
        $jshopConfig = &JSFactory::getConfig();
        if (!$jshopConfig->admin_show_product_video) return array();
        
        $query = "SELECT  video_name, video_id, video_preview FROM `#__jshopping_products_videos` WHERE product_id = '".$this->_db->getEscaped($this->product_id)."'";
        $this->_db->setQuery($query);
        return $this->_db->loadObjectList();
    }
    
    function getFiles() {        
        $jshopConfig = &JSFactory::getConfig();
        if (!$jshopConfig->admin_show_product_files) return array();
        
        $query = "SELECT * FROM `#__jshopping_products_files` WHERE product_id = '".$this->_db->getEscaped($this->product_id)."' order by `ordering` ";
        $this->_db->setQuery($query);
        return $this->_db->loadObjectList();
    }
    
    function getDemoFiles() {        
        $jshopConfig = &JSFactory::getConfig();
        if (!$jshopConfig->admin_show_product_files) return array();
        
        $query = "SELECT * FROM `#__jshopping_products_files` WHERE product_id = '".$this->_db->getEscaped($this->product_id)."' and demo!='' order by `ordering` ";
        $this->_db->setQuery($query);
        return $this->_db->loadObjectList();
    }
    
    function getSaleFiles() {
        $jshopConfig = &JSFactory::getConfig();
        if (!$jshopConfig->admin_show_product_files) return array();
        
        $query = "SELECT id, file, file_descr FROM `#__jshopping_products_files` WHERE product_id = '".$this->_db->getEscaped($this->product_id)."' and file!='' order by `ordering` ";
        $this->_db->setQuery($query);
        return $this->_db->loadObjectList();
    }
    
    function getManufacturerInfo(){        
        $manufacturers = &JSFactory::getAllManufacturer();
        if ($this->product_manufacturer_id && isset($manufacturers[$this->product_manufacturer_id])){
            return $manufacturers[$this->product_manufacturer_id];
        }else{
            return null;
        }        
    }

    function getRelatedProducts() {
        $jshopConfig = &JSFactory::getConfig();
        if (!$jshopConfig->admin_show_product_related){
            $this->product_related = array();
            return $this->product_related;
        }
        
        $lang = &JSFactory::getLang();
        
        $advquery = "";
        if ($jshopConfig->hide_product_not_avaible_stock){
            $advquery .= " AND prod.product_quantity > 0";
        }
        
        $query = "SELECT relation.product_related_id AS product_id, prod.product_price, pr_cat.category_id, prod.product_thumb_image, prod.`".$lang->get('name')."` as name, prod.product_tax_id as tax_id, prod.product_manufacturer_id, prod.product_weight, prod.min_price
                FROM `#__jshopping_products_relations` AS relation
                INNER JOIN `#__jshopping_products` AS prod ON relation.product_related_id = prod.product_id
                LEFT JOIN `#__jshopping_products_to_categories` AS pr_cat ON pr_cat.product_id = relation.product_related_id
                LEFT JOIN `#__jshopping_categories` AS cat ON pr_cat.category_id = cat.category_id
                WHERE relation.product_id = '" . $this->_db->getEscaped($this->product_id) . "' AND cat.category_publish='1' AND prod.product_publish = '1' ".$advquery." group by prod.product_id ";
        $this->_db->setQuery($query);        
        $this->product_related = $this->_db->loadObjectList();                
        foreach ($this->product_related as $key => $value) {
            $this->product_related[$key]->product_link = SEFLink('index.php?option=com_jshopping&controller=product&task=view&category_id='.$value->category_id.'&product_id='.$value->product_id);
        }        
        $this->product_related = listProductUpdateData($this->product_related);
        return $this->product_related;
    }

    /**
    * get first catagory for product
    */    
    function getCategory() {
        $query = "SELECT pr_cat.category_id FROM `#__jshopping_products_to_categories` AS pr_cat
                LEFT JOIN `#__jshopping_categories` AS cat ON pr_cat.category_id = cat.category_id
                WHERE pr_cat.product_id = '".$this->_db->getEscaped($this->product_id)."' AND cat.category_publish='1' LIMIT 0,1";
        $this->_db->setQuery($query);
        $this->category_id = $this->_db->loadResult();
        return $this->category_id;
    }
    
    function getExtendsData() {
        $this->getRelatedProducts();
        $this->getDescription();
        $this->getTax();
        $this->getPricePreview();
        $this->getDeliveryTime();
    }
    
    function getDeliveryTime(){
        $jshopConfig = &JSFactory::getConfig();
                
        if ($jshopConfig->show_delivery_time && $this->delivery_times_id){
            $deliveryTimes = &JTable::getInstance('deliveryTimes', 'jshop');
            $deliveryTimes->load($this->delivery_times_id);
            $this->delivery_time = $deliveryTimes->getName();
        }else{
            $this->delivery_time = "";    
        }
        return $this->delivery_time;
    }

    function getDescription() {
        $lang = &JSFactory::getLang();
        $name = $lang->get('name');
        $short_description = $lang->get('short_description');
        $description = $lang->get('description');
        $meta_title = $lang->get('meta_title');
        $meta_keyword = $lang->get('meta_keyword');
        $meta_description = $lang->get('meta_description');
        
        $this->name = $this->$name;
        $this->short_description = $this->$short_description;
        $this->description = $this->$description;
        $this->meta_title = $this->$meta_title;
        $this->meta_keyword = $this->$meta_keyword;
        $this->meta_description = $this->$meta_description;
    }
    
    function getPricePreview(){                
        $this->getPrice(1, 1, 1, 1);
        if ($this->product_is_add_price){
            $this->product_add_prices = array_reverse($this->product_add_prices);
        }
        $this->updateOtherPricesIncludeAllFactors();
    }
    
    function getPrice($quantity = 1, $enableCurrency = 1, $enableUserDiscount = 1, $enableParamsTax = 1) {
        $jshopConfig = &JSFactory::getConfig();
                
        $this->product_price_calculate = $this->getPriceWithParams();                
        
        if ($this->product_is_add_price){
            $this->getAddPrices();        
        }else{
            $this->product_add_prices = array();
        }
        
        if ($quantity && $this->product_is_add_price){
            foreach ($this->product_add_prices as $key=>$value){
                if ($quantity >= $value->product_quantity_start){
                    $this->product_price_calculate = $value->price;
                    break;    
                } 
            }
        }
        
        if ($enableCurrency){
            $this->product_price_calculate = $this->product_price_calculate * $jshopConfig->currency_value;
        }
        
        if ($enableUserDiscount){
            $userShop = &JSFactory::getUserShop();
            $this->product_price_calculate = getPriceDiscount($this->product_price_calculate, $userShop->percent_discount);    
        }
        
        if ($enableParamsTax){
            $this->product_price_calculate = getPriceCalcParamsTax($this->product_price_calculate, $this->product_tax_id);
        }
        
        return $this->product_price_calculate;
    }
    
    function getPriceCalculate(){
        return $this->product_price_calculate;
    }
    
    function getBasicPriceInfo(){
        $this->product_basic_price_show = ($this->weight_volume_units!=0 && $this->weight_volume_units!=1);
        if (!$this->product_basic_price_show) return 0; 
        
        $units = &JSFactory::getAllUnits();        
        $unit = $units[$this->basic_price_unit_id];
        $this->product_basic_price_calculate = $this->product_price_calculate / $this->weight_volume_units * $unit->qty;
              
        $this->product_basic_price_unit_name = $unit->name;
        $this->product_basic_price_unit_qty = $unit->qty;
        return 1;
    }
    
    function getAddPrices(){
        $jshopConfig = &JSFactory::getConfig();
        $productprice = &JTable::getInstance('productprice', 'jshop');                
        $this->product_add_prices = $productprice->getAddPrices($this->product_id);
        
        $price = $this->getPriceWithParams();        
        foreach($this->product_add_prices as $k=>$v){
            if ($jshopConfig->product_price_qty_discount == 1){
                $this->product_add_prices[$k]->price = $price - $v->discount; //discount value
            }else{
                $this->product_add_prices[$k]->price = $price - ($price * $v->discount / 100); //discount percent
            }
        }
    }
    
    function getTax() {
        $taxes = &JSFactory::getAllTaxes();    
        $this->product_tax = $taxes[$this->product_tax_id];
        return $this->product_tax;        
    }
    
    function updateOtherPricesIncludeAllFactors(){
        $jshopConfig = &JSFactory::getConfig();
        $userShop = &JSFactory::getUserShop();
        
        $this->product_old_price = $this->product_old_price * $jshopConfig->currency_value;
        $this->product_old_price = getPriceDiscount($this->product_old_price, $userShop->percent_discount);
        $this->product_old_price = getPriceCalcParamsTax($this->product_old_price, $this->product_tax_id);
        
        if (is_array($this->product_add_prices)){
            foreach ($this->product_add_prices as $key=>$value){            
                $this->product_add_prices[$key]->price = $this->product_add_prices[$key]->price * $jshopConfig->currency_value;
                $this->product_add_prices[$key]->price = getPriceDiscount($this->product_add_prices[$key]->price, $userShop->percent_discount);
                $this->product_add_prices[$key]->price = getPriceCalcParamsTax($this->product_add_prices[$key]->price, $this->product_tax_id);
            }
        }
    }    
    
    
    function getLastProducts($count, $array_categories = null) {
        $jshopConfig = &JSFactory::getConfig();             

        $db =& JFactory::getDBO();
        $lang = &JSFactory::getLang();
        $where_add = '';
        if(count($array_categories)) {
            $where_add .= "AND pr_cat.category_id IN (".implode(",", $array_categories).")";
        }
                
        if ($jshopConfig->hide_product_not_avaible_stock){
            $where_add .= " AND prod.product_quantity > 0";
        }
 
        $query = "SELECT prod.`".$lang->get('name')."` as name, prod.`".$lang->get('short_description')."` as short_description, prod.product_id, prod.product_ean, prod.product_thumb_image, pr_cat.category_id, prod.product_price, prod.product_tax_id as tax_id, prod.product_old_price, prod.product_weight, prod.average_rating, prod.reviews_count, prod.hits, prod.weight_volume_units, prod.basic_price_unit_id, prod.label_id, prod.product_manufacturer_id, prod.product_weight, prod.min_price
                  FROM `#__jshopping_products` AS prod
                  INNER JOIN `#__jshopping_products_to_categories` AS pr_cat ON pr_cat.product_id = prod.product_id
                  LEFT JOIN `#__jshopping_categories` AS cat ON pr_cat.category_id = cat.category_id
                  WHERE prod.product_publish = '1' AND cat.category_publish='1' " . $where_add . "
                  GROUP BY prod.product_id ORDER BY prod.product_date_added DESC LIMIT " . $count;
        $db->setQuery($query);
        $products = $db->loadObjectList();
        $products = listProductUpdateData($products);
        return $products;
    }
    
    function getRandProducts($count, $array_categories = null) {
        $jshopConfig = &JSFactory::getConfig();             

        $db =& JFactory::getDBO();
        $lang = &JSFactory::getLang();
        $where_add = '';
        if(count($array_categories)) {
            $where_add .= "AND pr_cat.category_id IN (".implode(",", $array_categories).")";            
        }
                
        if ($jshopConfig->hide_product_not_avaible_stock){
            $where_add .= " AND prod.product_quantity > 0";
        }
        
        $query = "SELECT count(distinct prod.product_id) FROM `#__jshopping_products` AS prod
                  INNER JOIN `#__jshopping_products_to_categories` AS pr_cat ON pr_cat.product_id = prod.product_id
                  LEFT JOIN `#__jshopping_categories` AS cat ON pr_cat.category_id = cat.category_id                  
                  WHERE prod.product_publish = '1' AND cat.category_publish='1' ".$where_add;
        $db->setQuery($query);
        $totalrow = $db->loadResult();                  
        $totalrow = $totalrow - $count;
        if ($totalrow < 0) $totalrow = 0;
        $limitstart = rand(0, $totalrow);
        
        $order = array();
        $order[] = "name asc";
        $order[] = "name desc";
        $order[] = "prod.product_price asc";
        $order[] = "prod.product_price desc";
        $orderby = $order[rand(0,3)];
                 
        $query = "SELECT prod.`".$lang->get('name')."` as name, prod.`".$lang->get('short_description')."` as short_description, prod.product_id, prod.product_ean, prod.product_thumb_image, pr_cat.category_id, prod.product_price, prod.product_tax_id as tax_id, prod.product_old_price, prod.product_weight, prod.average_rating, prod.reviews_count, prod.hits, prod.weight_volume_units, prod.basic_price_unit_id, prod.label_id, prod.product_manufacturer_id, prod.product_weight, prod.min_price
                  FROM `#__jshopping_products` AS prod
                  INNER JOIN `#__jshopping_products_to_categories` AS pr_cat ON pr_cat.product_id = prod.product_id
                  LEFT JOIN `#__jshopping_categories` AS cat ON pr_cat.category_id = cat.category_id
                  WHERE prod.product_publish = '1' AND cat.category_publish='1' " . $where_add . "
                  GROUP BY prod.product_id order by ".$orderby." LIMIT ".$limitstart.", ".$count;
        $db->setQuery($query);
        $products = $db->loadObjectList();
        $products = listProductUpdateData($products);        
        return $products;
    }    
    
    function getBestSellers($count, $array_categories = null){
        $jshopConfig = &JSFactory::getConfig();             

        $db =& JFactory::getDBO();
        $lang = &JSFactory::getLang();

        $where_add = '';
        if(count($array_categories)) {
            $where_add .= "AND pr_cat.category_id IN (".implode(",", $array_categories).")";
        }
        
        if ($jshopConfig->hide_product_not_avaible_stock){
            $where_add .= " AND prod.product_quantity > 0";
        }
 
        $query = "SELECT  SUM(OI.product_quantity) as max_num, prod.`".$lang->get('name')."` as name, prod.`".$lang->get('short_description')."` as short_description, prod.product_id, prod.product_ean, prod.product_thumb_image, pr_cat.category_id, prod.product_price, prod.product_tax_id as tax_id, prod.product_old_price, prod.product_weight, prod.average_rating, prod.reviews_count, prod.hits, prod.weight_volume_units, prod.basic_price_unit_id, prod.label_id, prod.product_manufacturer_id, prod.product_weight, prod.min_price
                  FROM #__jshopping_order_item AS OI 
                  INNER JOIN `#__jshopping_products` AS prod   ON prod.product_id=OI.product_id
                  INNER JOIN `#__jshopping_products_to_categories` AS pr_cat ON pr_cat.product_id = prod.product_id
                  LEFT JOIN `#__jshopping_categories` AS cat ON pr_cat.category_id = cat.category_id
                  WHERE prod.product_publish = '1' AND cat.category_publish='1' " . $where_add . "
                  GROUP BY prod.product_id
                  ORDER BY max_num desc LIMIT " . $count;
        $db->setQuery($query);
        $products = $db->loadObjectList();
        $products = listProductUpdateData($products);
        return $products;
    }
    
    function getProductLabel($label_id, $count){
        $jshopConfig = &JSFactory::getConfig();             

        $db =& JFactory::getDBO();
        $lang = &JSFactory::getLang();

        $where_add = '';
        if($label_id) {
            $where_add = " AND prod.label_id='".$db->getEscaped($label_id)."'";            
        }
        
        if ($jshopConfig->hide_product_not_avaible_stock){
            $where_add .= " AND prod.product_quantity > 0";
        }
 
        $query = "SELECT prod.`".$lang->get('name')."` as name, prod.product_id, prod.product_thumb_image, prod.product_price, pr_cat.category_id, prod.product_tax_id as tax_id , prod.product_old_price, prod.product_weight, prod.average_rating, prod.reviews_count, prod.hits, prod.weight_volume_units, prod.basic_price_unit_id, prod.label_id, prod.product_manufacturer_id, prod.product_weight, prod.min_price
                  FROM `#__jshopping_products` AS prod
                  INNER JOIN `#__jshopping_products_to_categories` AS pr_cat ON pr_cat.product_id = prod.product_id
                  LEFT JOIN `#__jshopping_categories` AS cat ON pr_cat.category_id = cat.category_id
                  WHERE prod.product_publish = '1' and prod.label_id!=0 AND cat.category_publish='1' ".$where_add."
                  GROUP BY prod.product_id ORDER BY name LIMIT ".$count;
        $db->setQuery($query);
        $products = $db->loadObjectList();
        $products = listProductUpdateData($products);
        return $products;
    }
    
    function getTopRatingProducts($count){
        $jshopConfig = &JSFactory::getConfig();

        $db =& JFactory::getDBO();
        $lang = &JSFactory::getLang();

        $where_add = '';        
        if ($jshopConfig->hide_product_not_avaible_stock){
            $where_add .= " AND prod.product_quantity > 0";
        }
 
        $query = "SELECT prod.`".$lang->get('name')."` as name, prod.product_id, prod.product_thumb_image, prod.product_price, pr_cat.category_id, prod.product_tax_id as tax_id, prod.product_old_price, prod.product_weight, prod.average_rating, prod.reviews_count, prod.hits, prod.weight_volume_units, prod.basic_price_unit_id, prod.label_id, prod.product_manufacturer_id, prod.product_weight, prod.min_price
                  FROM `#__jshopping_products` AS prod
                  INNER JOIN `#__jshopping_products_to_categories` AS pr_cat ON pr_cat.product_id = prod.product_id
                  LEFT JOIN `#__jshopping_categories` AS cat ON pr_cat.category_id = cat.category_id
                  WHERE prod.product_publish = '1' AND cat.category_publish='1' ".$where_add."
                  GROUP BY prod.product_id ORDER BY prod.average_rating desc LIMIT ".$count;
        $db->setQuery($query);
        $products = $db->loadObjectList();
        $products = listProductUpdateData($products);
        return $products;
    }
    
    
    function getReviews($limitstart = 0, $limit = 20) {
        $query = "SELECT * FROM `#__jshopping_products_reviews` WHERE product_id = '" . $this->_db->getEscaped($this->product_id) . "' order by review_id desc";
        $this->_db->setQuery($query, $limitstart, $limit);
        return $this->_db->loadObjectList();
    }
    
    function getReviewsCount(){
        $query = "SELECT count(review_id) FROM `#__jshopping_products_reviews` WHERE product_id = '" . $this->_db->getEscaped($this->product_id) . "'";
        $this->_db->setQuery($query);
        return $this->_db->loadResult();
    }

    function getAverageRating() {
        $query = "SELECT ROUND(AVG(mark),2) FROM `#__jshopping_products_reviews` WHERE product_id = '".$this->_db->getEscaped($this->product_id)."' and mark > 0";
        $this->_db->setQuery($query);
        return $this->_db->loadResult();
    }
    
    function loadAverageRating(){
        $this->average_rating = $this->getAverageRating();        
    }
    
    function loadReviewsCount(){
        $this->reviews_count = $this->getReviewsCount();
    }

}
?>